<?php
/**
* History:
*
* 1.0.0 - First version
* 1.1.0 - display informations of the TPL (file and template)
* 1.1.1 - add "*" for select all address IP
* 1.2.0 - add CSS and JS for each modules
* 1.2.1 - optimization display
* 1.2.2 - optimization display (icon)
* 1.2.3 - open block H-M by hover or click
* 1.2.4 - add Module::isEnabled in overrides
* 1.2.5 - displaying the full url of the template
* 1.2.6 - modification of CSS for display "+", this "+" will not be displayed with the themes that have not bootstrap)
* 1.2.7 - option "front office only" and option "all the time" for display all datas without click
* 1.2.8 - small patch
* 1.3.0 - option display/hide informations with the touch ²
* 1.3.1 - the key ² was not recognized on firefox, problem corrected
* 1.4.0 - compatible prestashop 1.7 RC3
* 1.4.1 - compatible prestashop 1.7.1
* 1.5.0 - update back office configuration
*
*  @author    Vincent MASSON <contact@coeos.pro>
*  @copyright Vincent MASSON <www.coeos.pro>
*  @license   http://www.coeos.pro/fr/content/3-conditions-generales-de-ventes
*/

class Hook extends HookCore
{
    public static function exec(
        $hook_name,
        $hook_args = array(),
        $id_module = null,
        $array_return = false,
        $check_exceptions = true,
        $use_push = false,
        $id_shop = null,
        $chain = false
    ) {
        $output = parent::exec(
            $hook_name,
            $hook_args,
            $id_module,
            $array_return,
            $check_exceptions,
            $use_push,
            $id_shop,
            $chain
        );
        $live_edit = (Tools::isSubmit('live_edit'))? true : false;
        if (!$module_list = Hook::getHookModuleExecList($hook_name)) {
            return '';
        }
        $ip = Configuration::get('witm_config');
        $ip_array = explode(',', $ip);
        $before_output = '';
        $after_output = '';
        if ((in_array(Tools::getRemoteAddr(), $ip_array)
                || in_array('*', $ip_array)) && Module::isEnabled('whatisthismodule')
            && (!defined('_PS_ADMIN_DIR_'))) {
            if (Configuration::get('witm_h_m') == 1) {
                $before_output .= '
                <div class="div_infos_hook">
                <span class="infos_hook">
                    <span class="hm" onclick="display_infos_hook(\''.$hook_name.'\')">
                    <i class="icon-expand-alt icon-large"></i> H-M</span>
                    <span class="hook_module" id="hook_module_'.$hook_name.'">
                    <span class="hook">HOOK : </span>'.$hook_name.'<div class="see_modules">
                    <span class="modules">Modules : </span><br/>
                        <span id="d_m_'.$hook_name.'" class="display_modules">';
            }
            if (Configuration::get('witm_h_m') == 2) {
                $before_output .= '
                <div class="div_infos_hook">
                <span class="infos_hook"><span class="hm">H-M</span><br/>
                <span class="hook_module"><span class="hook">HOOK :</span> '.$hook_name.'
                <div class="see_modules">
                    <span class="modules">Modules : </span>
                    <span id="d_m_'.$hook_name.'" class="display_modules">';
            }
            if (Configuration::get('witm_h_m') == 3) {
                $before_output .= '
                <div class="div_infos_hook">
                <span class="infos_hook">
                <span><span class="hook">HOOK : </span>'.$hook_name.'
                <div><span class="modules">MODULES :</span>
                <span>';
            }
            if (Configuration::get('witm_h_m') == 4) {
                $before_output .= '
                <div class="div_infos_hook">
                <span class="infos_hook witm">
                    <span>
                        <span class="hook witm">HOOK : </span><span class="witm">'.$hook_name.'</span>
                            <div>
                                <span class="modules witm">MODULES :</span>
                <span>';
            }
            $css_js = (int)Configuration::get('witm_css_js');
            $img = '<img class="img_ont"
                src="'.Context::getContext()->shop->physical_uri.
                    '/modules/whatisthismodule/views/img/open_new_tab.png"/>';
            foreach ($module_list as $module) {
                $css = '';
                $js = '';
                if ($css_js == 1) {
                    if (version_compare(_PS_VERSION_, '1.7', '<')) {
                        foreach (Context::getContext()->controller->css_files as $key => $value) {
                            if (strstr($key, '/'.$module['module'].'/')) {
                                $css .= '<br/> <a class="file_css witm" href="'.$key.'" target="_blank">
                                <span class="css witm">CSS</span> : '.$key.' '.$img.'</a>';
                            }
                        }
                        foreach (Context::getContext()->controller->js_files as $key => $value) {
                            if (strstr($value, '/'.$module['module'].'/')) {
                                $js .= '<br/> <a class="file_js witm" href="'.$value.'" target="_blank">
                                <span class="js witm">JS</span> : '.$value.' '.$img.'</a>';
                            }
                        }
                    } else {
                        $css_files = Context::getContext()->controller->getStylesheets();
                        $js_files = Context::getContext()->controller->getJavascript();
                        foreach ($css_files['external'] as $key => $value) {
                            if (strstr($value['uri'], $module['module'])) {
                                $css .= '<br/> <a class="file_css witm" href="'.$value['uri'].'" target="_blank">
                                <span class="css witm">CSS </span> : '.$value['uri'].' '.$img.'</a>';
                            }
                        }
                        foreach ($js_files['head']['external'] as $key => $value) {
                            if (strstr($value['uri'], $module['module'])) {
                                $js .= '<br/> <a class="file_js witm" href="'.$value['uri'].'" target="_blank">
                                <span class="js witm">JS (head)</span> : '.$value['uri'].' '.$img.'</a>';
                            }
                        }
                        foreach ($js_files['bottom']['external'] as $key => $value) {
                            if (strstr($value['uri'], $module['module'])) {
                                $js .= '<br/> <a class="file_js witm" href="'.$value['uri'].'" target="_blank">
                                <span class="js witm">JS (bottom)</span> : '.$value['uri'].' '.$img.'</a>';
                            }
                        }
                    }
                }
                $before_output .= '<br/>
                    <span class="witm"> - '.$module['module'].
                        (($css != '' && $js != '')? ' : ' : '').$css.$js.'</span>';
            }
            $before_output .= '</span></div></span></span>';
            $after_output .= '</div>';
            if ($array_return) {
                return $output;
            } else {
                return ($live_edit ? '<script type="text/javascript">hooks_list.push(\''.$hook_name.'\');</script>
                    <div id="'.$hook_name.'" class="dndHook" style="min-height:50px">' : '').
                    $before_output.$output.$after_output.($live_edit ? '</div>' : '');
            }
        } else {
            return $output;
        }
    }
}
