<?php
/**
* History:
*
* 1.0.0 - First version
* 1.1.0 - display informations of the TPL (file and template)
* 1.1.1 - add "*" for select all address IP
* 1.2.0 - add CSS and JS for each modules
* 1.2.1 - optimization display
* 1.2.2 - optimization display (icon)
* 1.2.3 - open block H-M by hover or click
* 1.2.4 - add Module::isEnabled in overrides
* 1.2.5 - displaying the full url of the template
* 1.2.6 - modification of CSS for display "+", this "+" will not be displayed with the themes that have not bootstrap)
* 1.2.7 - option "front office only" and option "all the time" for display all datas without click
* 1.2.8 - small patch
* 1.3.0 - option display/hide informations with the touch ²
* 1.3.1 - the key ² was not recognized on firefox, problem corrected
* 1.4.0 - compatible prestashop 1.7 RC3
* 1.4.1 - compatible prestashop 1.7.1
* 1.5.0 - update back office configuration
*
*  @author    Vincent MASSON <contact@coeos.pro>
*  @copyright Vincent MASSON <www.coeos.pro>
*  @license   http://www.coeos.pro/fr/content/3-conditions-generales-de-ventes
*/

class Module extends ModuleCore
{
    public function display($file, $template, $cache_id = null, $compile_id = null)
    {
        $result = parent::display($file, $template, $cache_id, $compile_id);
        $ip = Configuration::get('witm_config');
        $ip_array = explode(',', $ip);
        if (!in_array(Tools::getRemoteAddr(), $ip_array) && !in_array('*', $ip_array)
            || !Module::isEnabled('whatisthismodule')
            || (defined('_PS_ADMIN_DIR_') && (int)Configuration::get('witm_fo') == 1)
            ) {
            return $result;
        }
        if (Configuration::get('witm_h_m') == 1) {
            return '
            <div class="div_infos_tpl tpls">
                <span class="tpl" onclick="display_file_template_tpl(\''.md5($file.$template).'\')">TPL</span>
                <div id="'.md5($file.$template).'" class="file_template">
                    <span class="file">FILE : </span><span class="filename">'.$file.'</span><br/>
                    <span class="template">TEMPLATE : </span>
                    <span class="template_file">'.parent::getTemplatePath($template).'</span>
                </div>
                '.$result.'
            </div>';
        }
        if (Configuration::get('witm_h_m') == 2) {
            return '
            <div class="div_infos_tpl tpls">
                <span class="tpl"><i class="icon-expand-alt icon-large"></i> TPL</span><br/>
                <div id="'.md5($file.$template).'" class="file_template">
                    <span class="file">FILE : </span><span class="filename">'.$file.'</span><br/>
                    <span class="template">TEMPLATE : </span>
                    <span class="template_file">'.parent::getTemplatePath($template).'</span>
                </div>
                '.$result.'
            </div>';
        }
        if (Configuration::get('witm_h_m') == 3) {
            return '<div class="tpls">
            <span class="tpl">TPL :</span><br/>
            <span class="file">FILE : </span><span class="tpl_file">'.$file.'</span><br/>
            <span class="template">TEMPLATE : 
            </span><span class="template_file">'.parent::getTemplatePath($template).'</span>'.$result.'</div>';
        }
        
        if (Configuration::get('witm_h_m') == 4) {
            return '<div class="tpls">
            <span class="tpl witm">TPL :<br/></span>
            <span class="file witm">FILE : </span><span class="tpl_file witm">'.$file.'<br/></span>
            <span class="template witm">TEMPLATE :
            </span><span class="template_file witm">'.parent::getTemplatePath($template).'</span>'.$result.'</div>';
        }
        
        return '<div class="div_infos_tpl">
            <span class="infos_tpl"><strong>TPL</strong><span class="file_template"><strong>FILE :</strong>
            '.$file.'<br/><strong>TEMPLATE : </strong>
            '.parent::getTemplatePath($template).'</span></span>'.$result.'</div>';
    }

    public function fetch($template, $cache_id = null, $compile_id = null)
    {
        $result = parent::fetch($template, $cache_id, $compile_id);
        $gettemplatepath = parent::getTemplatePath($template);
        $gettemplatepath = ($gettemplatepath !== null)? $gettemplatepath : $template;
        
        
        $gettemplatepath = parent::_isTemplateOverloadedStatic($this->name, $gettemplatepath);
        $gettemplatepath = ($gettemplatepath !== null)? $gettemplatepath : $template;
        
        $ip = Configuration::get('witm_config');
        $ip_array = explode(',', $ip);
        if (!in_array(Tools::getRemoteAddr(), $ip_array)
            && !in_array('*', $ip_array)
            || !Module::isEnabled('whatisthismodule')
            || (defined('_PS_ADMIN_DIR_') && (int)Configuration::get('witm_fo') == 1)
            ) {
            return $result;
        }
        if (Configuration::get('witm_h_m') == 1) {
            return '
            <div class="div_infos_tpl tpls">
                <span class="tpl" onclick="display_file_template_tpl(\''.md5($template).'\')">TPL</span>
                <div id="'.md5($template).'" class="file_template">
                    <span class="template">TEMPLATE : </span>
                    <span class="template_file">'.$gettemplatepath.'</span>
                </div>
                '.$result.'
            </div>';
        }
        if (Configuration::get('witm_h_m') == 2) {
            return '
            <div class="div_infos_tpl tpls">
                <span class="tpl"><i class="icon-expand-alt icon-large"></i> TPL</span><br/>
                <div id="'.md5($template).'" class="file_template">
                    <span class="template">TEMPLATE : </span>
                    <span class="template_file">'.$gettemplatepath.'</span>
                </div>
                '.$result.'
            </div>';
        }
        if (Configuration::get('witm_h_m') == 3) {
            return '<div class="tpls">
            <span class="tpl">TPL :</span><br/>
            <span class="template">TEMPLATE : </span>
            <span class="template_file">'.$gettemplatepath.'</span>'.$result.'</div>';
        }
        
        if (Configuration::get('witm_h_m') == 4) {
            return '<div class="tpls">
            <span class="tpl witm">TPL :<br/></span>
            <span class="template witm">TEMPLATE : </span>
            <span class="template_file witm">'.$gettemplatepath.'</span>'.$result.'</div>';
        }
        
        return '<div class="div_infos_tpl"><span class="infos_tpl"><strong>TPL</strong></span>'.$result.'</div>';
    }
}
